void load_UI(ControlP5 cp5)
{

    cp5.addButton("Serial_clear")
      .setPosition(500,10)
      .setVisible(false)
      .setSize(60,60);
// ******************************************************************
// ************************** Tabs **********************************
// ******************************************************************
  cp5.getTab("default")
     .setLabel("Main")
     .setSize(100,100);
     
  cp5.addTab("Settings")
     .setColorBackground(color(0, 160, 100))
     .setColorLabel(color(255))
     .setColorActive(color(255,128,0))
     .setSize(100,100);
     
  cp5.addTab("Information")
     .setColorBackground(color(0, 160, 100))
     .setColorLabel(color(255))
     .setColorActive(color(255,128,0))
     .setSize(100,100);
  
// ******************************************************************
// ************************ In-put **********************************
// ******************************************************************
//------------------------- Top Buttons ----------------------------
  input = cp5.addGroup("Commands")
      .setPosition(20,50)
      .setBackgroundHeight(600)
      .setBackgroundColor(color(255,50))
      .setWidth(230)
      .setVisible(true)
      .moveTo("default");
      
  cp5.addButton("Do_math")
      .setPosition(120,10)
      .setSize(45,45)
      .setGroup(input);
      
  cp5.addButton("Halt")
      .setPosition(175,10)
      .setSize(45,100)
      .setGroup(input);
      
  start = cp5.addButton("Start")
      .setPosition(10,10)
      .setSize(100,100)
      .setGroup(input);
      
  stop = cp5.addButton("Stop")
      .setPosition(10,120)
      .setSize(100,40)
      .setGroup(input);
      
  reset_inc = cp5.addButton("Reset_Inc")
      .setPosition(120,65)
      .setSize(45,95)
      .setGroup(input);
      
  cp5.addButton("Reset_err")
      .setPosition(175,120)
      .setSize(45,40)
      .setGroup(input);
      
  block_input = cp5.addButton("Block_input")
      .setPosition(-15,-15)
      .setSize(260,630)
      .setLabelVisible(false)
      .setColorBackground(color(0,0,0,95))
      .setColorActive(color(0,0,0,95))
      .setColorForeground(color(0,0,0,95))
      .setGroup(input);
      
// --------------------- Properties ---------------------   
  list = cp5.addListBox("Nodes")
      .setPosition(20,170)
      .setSize(180,30)//170
      .setItemHeight(25)
      .setBarHeight(30)
      .setColorActive(color(0,150,200))
      .setColorForeground(color(255,100,0))
      .setGroup(input);
      
  Group properties = cp5.addGroup("Properties")
      .setPosition(25,370)
      .setBackgroundHeight(170)
      .setBackgroundColor(color(255,50))
      .setWidth(180)
      .setGroup(input);
      
  cp5.addButton("Apply_Changes")
      .setPosition(20, 10)
      .setSize(140,45)
      .setGroup(properties);
 /*     
  posX = cp5.addTextfield("pX")
      .setPosition(10,10)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  posY = cp5.addTextfield("pY")
      .setPosition(65,10)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  posZ = cp5.addTextfield("pZ")
      .setPosition(120,10)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  rotX = cp5.addTextfield("rX")
      .setPosition(10,40)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  rotY = cp5.addTextfield("rY")
      .setPosition(65,40)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  rotZ = cp5.addTextfield("rZ")
      .setPosition(120,40)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
   */   
  P = cp5.addTextfield("P")
      .setPosition(10,70)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  I = cp5.addTextfield("I")
      .setPosition(65,70)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  D = cp5.addTextfield("D")
      .setPosition(120,70)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  vel = cp5.addTextfield("Velocity")
      .setPosition(10,115)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  accel = cp5.addTextfield("Acceleration")
      .setPosition(65,115)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
      
  point = cp5.addTextfield("Point")
      .setPosition(120,115)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setGroup(properties);
   
//------------------- Other(Input) --------------------
  COM_warning = cp5.addTextarea("COM_state")
      .setPosition(10,550)
      .setSize(210,40)
      .setFont(createFont("arial",18))
      .setLineHeight(14)
      .setColor(color(0))
      .setColorBackground(color(150))
      .setColorForeground(color(255,100))
      .setText("      No connection")
      .setGroup(input);
   
//*****************************************************
//*************** DH parameters ***********************
//*****************************************************
   
//---------------------- propeDH_para---------------
Group DH_para = cp5.addGroup("DH Parameters")
      .setPosition(60,60)
      .setBackgroundHeight(350)
      .setBackgroundColor(color(255,50))
      .setWidth(180)
      .moveTo("Settings");
      
  DH_a = cp5.addTextfield("DH a")
      .setPosition(10,10)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setText("0")
      .setGroup(DH_para);
      
  DH_alpha = cp5.addTextfield("DH alpha")
      .setPosition(65,10)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setText("0")
      .setGroup(DH_para);
      
  DH_d = cp5.addTextfield("DH d")
      .setPosition(120,10)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setText("0")
      .setGroup(DH_para);
      
  pos_limit = cp5.addTextfield("+ limit")
      .setPosition(120,55)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setText("45")
      .setGroup(DH_para);
      
  neg_limit = cp5.addTextfield("- limit")
      .setPosition(10,55)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setText("-45")
      .setGroup(DH_para);
/*      
  gear_ratio = cp5.addTextfield("Gear Ratio")
      .setPosition(60,100)
      .setSize(50,25)
      .setFont(createFont("arial",18))
      .setColor(color(0))
      .setColorBackground(color(200))
      .setText("-45")
      .setGroup(DH_para);
      
  cp5.addTextlabel("Ge_Ra")
      .setText(":1")
      .setPosition(110,100)
      .setColorValue(color(0))
      .setFont(createFont("Georgia",20))
      .setGroup(DH_para);
*/      
  bit_type = cp5.addToggle("Bit_type")
      .setPosition(65,160)
      .setSize(50,25)
      .setValue(true)
      .setMode(ControlP5.SWITCH)
      .setLabelVisible(false)
      .setGroup(DH_para);
      
  cp5.addTextlabel("15_bit")
      .setText("15-bit")
      .setPosition(10,160)
      .setColorValue(color(0))
      .setFont(createFont("Georgia",16))
      .setGroup(DH_para);
      
  cp5.addTextlabel("12_bit")
      .setText("12-bit")
      .setPosition(115,160)
      .setColorValue(color(0))
      .setFont(createFont("Georgia",16))
      .setGroup(DH_para);
       
  cp5.addButton("Add")
      .setPosition(10,195)
      .setSize(160,40)
      .setGroup(DH_para);
      
  cp5.addButton("Delete")
      .setPosition(10,245)
      .setSize(160,40)
      .setGroup(DH_para);
      
  cp5.addButton("End_effector")
      .setPosition(10,295)
      .setSize(160,40)
      .setGroup(DH_para);
      
  block_DH = cp5.addButton("Block_DH")
      .setPosition(-15,-15)
      .setSize(210,380)
      .setLabelVisible(false)
      .setColorBackground(color(0,0,0,95))
      .setColorActive(color(0,0,0,95))
      .setColorForeground(color(0,0,0,95))
      .setGroup(DH_para);

// ******************************************************************
// ************************ Control *********************************
// ******************************************************************
//---------------------- Profily Motion ----------------
  Group control = cp5.addGroup("Control")
      .setPosition(760,20)
      .setBackgroundHeight(360)
      .setBackgroundColor(color(255,50))
      .setWidth(230)
      .moveTo("default");

  p_move = cp5.addTextfield("P_Velocity")
      .setPosition(10,10)
      .setSize(100,25)
      .setFont(createFont("arial",18))
      .setText("0")
      .setGroup(control);
      
  B_Pmove = cp5.addButton("P_Move")
      .setPosition(130, 10)
      .setSize(90,30)
      .setLock(true)
      .setGroup(control); 
      
  PVelocity_Slider = cp5.addSlider("Profiled_Velocity_Slider")
     .setPosition(10,50)
     .setSize(140,20)
     .setRange(-slider_range,slider_range)
     .setValue(0)
     .setCaptionLabel("")
     .setGroup(control);
           
  p_position = cp5.addTextfield("P_Position")
      .setPosition(10,100)
      .setSize(100,25)
      .setFont(createFont("arial",18))
      .setText("0")
      .setGroup(control);
      
  B_Pgoto = cp5.addButton("P_Go_to")
      .setPosition(130, 100)
      .setSize(90,30)
      .setLock(true)
      .setGroup(control);  
      
  PPosition_Slider = cp5.addSlider("Profiled_Position_Slider")
     .setPosition(10,140)
     .setSize(160,20)
     .setRange(-slider_range,slider_range)
     .setValue(0)
     .setCaptionLabel("")
     .setGroup(control);
      
// --------------------- Motion --------------------- 
  move = cp5.addTextfield("Velocity.")
      .setPosition(10,190)
      .setSize(100,25)
      .setFont(createFont("arial",18))
      .setText("0")
      .setGroup(control);
      
  B_move = cp5.addButton("Move")
      .setPosition(130, 190)
      .setSize(90,30)
      .setLock(true)
      .setGroup(control);
      
  Velocity_Slider = cp5.addSlider("Velocity_Slider")
     .setPosition(10,230)
     .setSize(160,20)
     .setRange(-slider_range,slider_range)
     .setValue(0)
     .setCaptionLabel("")
     .setGroup(control);
      
  position = cp5.addTextfield("Position")
      .setPosition(10,280)
      .setSize(100,25)
      .setFont(createFont("arial",18))
      .setText("0")
      .setGroup(control);

  B_goto = cp5.addButton("Go_to")
      .setPosition(130, 280)
      .setSize(90,30)
      .setLock(true)
      .setGroup(control);  
      
  Position_Slider = cp5.addSlider("Position_Slider")
     .setPosition(10,320)
     .setSize(160,20)
     .setRange(-slider_range,slider_range)
     .setValue(0)
     .setCaptionLabel("")
     .setGroup(control);
     
  block_control = cp5.addButton("Block_control")
      .setPosition(-15,-15)
      .setSize(260,390)
      .setLabelVisible(false)
      .setColorBackground(color(0,0,0,95))
      .setColorActive(color(0,0,0,95))
      .setColorForeground(color(0,0,0,95))
      .setGroup(control);
      
// ******************************************************************
// ************************ --------- *******************************
// ******************************************************************
      
//------------------------- Warning msg -----------------------------
  Connect_msg = cp5.addTextlabel("label")
      .setText("Please select a COM from the 'Seting' tab")
      .setPosition(300,80)
      .setColorValue(0xfffff000)
      .setFont(createFont("Georgia",20))
      .moveTo("default");
      
// ******************************************************************
// ************************ PID Error *******************************
// ******************************************************************
  Group PID_error = cp5.addGroup("PID Error")
      .setPosition(width - 170, 20)
      .setBackgroundHeight(100)
      .setBackgroundColor(color(255,50))
      .setWidth(150)
      .setVisible(false)
      .moveTo("default");
      
  PID_error_txt = cp5.addTextarea("txt")
      .setPosition(10,10)
      .setSize(130,40)
      .setFont(createFont("arial",12))
      .setLineHeight(14)
      .setColor(color(128))
      .setColorBackground(color(74,0,101))
      .setColorForeground(color(255,100))
      .setGroup(PID_error);
      
  cp5.addButton("Reset_PID")
      .setPosition(10, 60)
      .setSize(130,30)
      .setGroup(PID_error); 
      
      
// ******************************************************************
// ************************ Real ticks and angles *******************
// ******************************************************************
/*
  plane = cp5.addSlider2D("wave")
       .setPosition(900,500)
       .setSize(100,100)
       .setArrayValue(new float[] {50, 50});
*/
// ******************************************************************
// ************************ Color Settings **************************
// ******************************************************************
  Group elem_color = cp5.addGroup("Colors")
      .setPosition(700,400)
      .setBackgroundHeight(180)
      .setBackgroundColor(color(255,50))
      .setWidth(280)
      .moveTo("Settings");
      
  BG_cl = cp5.addColorPicker("BackGround")
      .setPosition(10,10)
      .setColorValue(color(120,120,120))
      .activateEvent(false)
      .setGroup(elem_color);
      
  J_cl = cp5.addColorPicker("Joint Color")
      .setPosition(10,90)
      .setColorValue(color(255, 20, 20))
      .activateEvent(false)
      .setGroup(elem_color);

// ******************************************************************
// ************************ Port ************************************
// ******************************************************************
  Group COM = cp5.addGroup("COM")
      .setPosition(700,75)
      .setBackgroundHeight(240)
      .setBackgroundColor(color(255,50))
      .setWidth(280)
      .moveTo("Settings");

  COM_list = cp5.addListBox("COMs")
      .setPosition(20,20)
      .setSize(160,160)
      .setItemHeight(25)
      .setBarHeight(30)
      .setColorActive(color(0,150,200))
      .setColorForeground(color(255,100,0))
      .setGroup(COM);
      
  cp5.addButton("Detect")
      .setPosition(210,20)
      .setSize(50,50)
      .setGroup(COM);
      
  cp5.addButton("Connect")
      .setPosition(210,80)
      .setSize(50,50)
      .setGroup(COM);
      
  COM_status = cp5.addTextarea("COM_status")
      .setPosition(10,180)
      .setSize(260,40)
      .setFont(createFont("arial",20))
      .setLineHeight(14)
      .setColor(color(0))
      .setColorBackground(color(255,10,10))
      .setColorForeground(color(255,100))
      .setText("         No connection")
      .setGroup(COM);
      
// ******************************************************************
// ************************ Save/Load *******************************
// ******************************************************************
      
  Group configuration = cp5.addGroup("configuration")
      .setPosition(60,470)
      .setBackgroundHeight(160)
      .setBackgroundColor(color(255,50))
      .setWidth(190)
      //.setVisible(false)
      .moveTo("Settings");
      
  cp5.addButton("Save")
      .setPosition(10,10)
      .setSize(75,50)
      .setGroup(configuration);
      
  cp5.addButton("Load")
      .setPosition(105,10)
      .setSize(75,50)
      .setGroup(configuration);
      
  SL_path = cp5.addTextfield("Path")
      .setPosition(10,80)
      .setSize(170,25)
      .setFont(createFont("arial",18))
      .setText("def")
      .setGroup(configuration);
      
  block_SL = cp5.addButton("Block_SL")
      .setPosition(-15,-15)
      .setSize(220,190)
      .setLabelVisible(false)
      .setColorBackground(color(0,0,0,95))
      .setColorActive(color(0,0,0,95))
      .setColorForeground(color(0,0,0,95))
      .setGroup(configuration);
      
// ******************************************************************
// ************************ Other ***********************************
// ******************************************************************   
  cp5.addButton("Image")
     .setPosition(900,550)
     .setImages(loadImage("logo.jpg"), loadImage("logo.jpg"), loadImage("logo.jpg"))
     .updateSize()
     .moveTo("Information");
     
  cp5.addTextarea("Load code to arduino")
      .setPosition(10,50)
      .setSize(800,200)
      .setFont(createFont("Georgia",16))
      .setLineHeight(14)
      .setColor(color(0))
      //.setColorBackground(color(255,10,10))
      //.setColorForeground(color(255,100))
      .setText("No connection")
      .moveTo("Information")
      .setText("First, you need to add our 01SMS Arduino Library. "
             +" To do this simple open your Arduino IDE. Go to Sketch>Import Library>Add Library"
             +" Then browse to the folder where you unziped the 01Robot programme. There you will find a"
             +" zip file named ZerooneSupermodified103.zip. Click on it and press OK"
              );
  cp5.addTextarea("Load code to arduino2")
      .setPosition(10,120)
      .setSize(800,200)
      .setFont(createFont("Georgia",16))
      .setLineHeight(14)
      .setColor(color(0))
      //.setColorBackground(color(255,10,10))
      //.setColorForeground(color(255,100))
      .setText("No connection")
      .moveTo("Information")
      .setText("Now you need to burn our Arduino code on your device. Click File>Open and browse"
             +" to the unziped folder again. There you will find a folder with the name Arduino in it."
             +" That folder will contain a .ino file. Open it and click upload"
              ); 
              
  cp5.addTextarea("Load code to arduino3")
      .setPosition(10,180)
      .setSize(800,200)
      .setFont(createFont("Georgia",16))
      .setLineHeight(14)
      .setColor(color(0))
      //.setColorBackground(color(255,10,10))
      //.setColorForeground(color(255,100))
      .setText("No connection")
      .moveTo("Information")
      .setText("Now double click on the .exe file of the 01Robot programme and you are good to go!"); 
              
  cp5.addTextarea("Load code to arduino4")
      .setPosition(10,210)
      .setSize(800,200)
      .setFont(createFont("Georgia",16))
      .setLineHeight(14)
      .setColor(color(0))
      //.setColorBackground(color(255,10,10))
      //.setColorForeground(color(255,100))
      .setText("No connection")
      .moveTo("Information")
      .setText("Please consult the manual for extra information."); 
              
    
}